
(* Nombre: Juan P. Zofio Perez         Titulacion: I.T.I.Gestion
   Fecha: 27 de Septiembre de 1999     Curso: 1C              *)
MODULE Ajugar;
IMPORT Marciano, IO, Window, Lib;
VAR
  espacio:Marciano.ESPACIO;
  minavedestruida, error:BOOLEAN;
  coorescuadron:Marciano.COORESCUADRON;
  muertos, posicion, nivel:CARDINAL;
  direccion:Marciano.DIRECCION;


        (* Representa el espacio del conflicto *)
PROCEDURE Ventana();
VAR
  ventanadef:Window.WinDef;
  ventana:Window.WinType;
BEGIN
    WITH ventanadef DO
         X1:=10;
         Y1:=1;
         X2:=70;
         Y2:=25;
         Background:=Window.Blue;
         Foreground:=Window.Cyan;
    END;
    ventana:=Window.Open(ventanadef);
    Window.PutOnTop(ventana);
END Ventana;

        (* Presentacion al iniciar el juego *)
PROCEDURE Go();
BEGIN
    Window.GotoXY(12,5);IO.WrStr("GGGGGGGGGGGGG              OOOOOOOO");
    Window.GotoXY(11,6);IO.WrStr("GGGGGGGGGGGGGGG           OOOOOOOOOOOO");
    Window.GotoXY(10,7);IO.WrStr("GGGGGGGGGGGGGGGGG         OOOOOOOOOOOOOO");
    Window.GotoXY(10,8);IO.WrStr("GGGGG        GGGG         OOOO      OOOO");
    Window.GotoXY(10,9);IO.WrStr("GGGG          GGG        OOOO        OOOO");
    Window.GotoXY(10,10);IO.WrStr("GGGG                     OOOO        OOOO");
    Window.GotoXY(10,11);IO.WrStr("GGGG                     OOOO        OOOO");
    Window.GotoXY(10,12);IO.WrStr("GGGG                     OOOO        OOOO");
    Window.GotoXY(10,13);IO.WrStr("GGGG       GGGGGG        OOOO        OOOO");
    Window.GotoXY(10,14);IO.WrStr("GGGG       GGGGGG        OOOO        OOOO");
    Window.GotoXY(10,15);IO.WrStr("GGGG       GGGGGG        OOOO        OOOO");
    Window.GotoXY(10,16);IO.WrStr("GGGG         GGGG        OOOO        OOOO");
    Window.GotoXY(10,17);IO.WrStr("GGGG         GGGG        OOOO        OOOO");
    Window.GotoXY(10,18);IO.WrStr("GGGGG       GGGGG         OOOO      OOOO");
    Window.GotoXY(10,19);IO.WrStr("GGGGGGGGGGGGGGGGG         OOOOOOOOOOOOOO");
    Window.GotoXY(11,20);IO.WrStr("GGGGGGGGGGGGGGG           OOOOOOOOOOOO");
    Window.GotoXY(12,21);IO.WrStr("GGGGGGGGGGGGG              OOOOOOOO");

    Lib.Sound(5000);
    Lib.Delay(400);
    Lib.Sound(4000);
    Lib.Delay(400);
    Lib.Sound(3000);
    Lib.Delay(400);
    Lib.Sound(2000);
    Lib.Delay(400);
    Lib.Sound(1000);
    Lib.Delay(400);
    Lib.Sound(2000);
    Lib.Delay(400);
    Lib.Sound(3000);
    Lib.Delay(400);
    Lib.Sound(4000);
    Lib.Delay(400);
    Lib.Sound(5000);
    Lib.Delay(400);
    Lib.NoSound();

END Go;

        (* Escribe el mensaje final *)
PROCEDURE MensajeFinal(minavedestruida:BOOLEAN);
BEGIN
    IF minavedestruida THEN
       Window.GotoXY(10,10);
       IO.WrStr(" La alianza te ha vencido, MALETILLA!!");
    ELSE
       Window.GotoXY(10,10);
       IO.WrStr(" Te los cargaste a todos, CAMPEON!!");
    END;
END MensajeFinal;

        (* Ejecuta el juego en nivel experto, los niveles de juego solo
           se diferencian en el tiempo de retraso(Lib.Delay) *)
PROCEDURE NivelExperto(VAR espacio:Marciano.ESPACIO;VAR minavedestruida:BOOLEAN;
                 VAR coorescuadron:Marciano.COORESCUADRON;VAR muertos:CARDINAL);
BEGIN
    REPEAT
         Lib.Delay(5);
         Marciano.MoverEscuadron(espacio,coorescuadron,muertos,minavedestruida);
         Marciano.VisualizarEspacio(espacio);
         Marciano.Disparar(espacio,posicion,muertos,minavedestruida);
         Marciano.VisualizarEspacio(espacio);
         Lib.Delay(5);
         Marciano.Disparar(espacio,posicion,muertos,minavedestruida);
         Marciano.VisualizarEspacio(espacio);
         Lib.Delay(5);
         Marciano.Disparar(espacio,posicion,muertos,minavedestruida);
         Marciano.VisualizarEspacio(espacio);
         Lib.Delay(5);
         Marciano.Disparar(espacio,posicion,muertos,minavedestruida);
         Marciano.VisualizarEspacio(espacio);
    UNTIL (muertos=50) OR (minavedestruida);
END NivelExperto;


        (* Ejecuta el juego en nivel medio, los niveles de juego solo
           se diferencian en el tiempo de retraso(Lib.Delay) *)
PROCEDURE NivelMedio(VAR espacio:Marciano.ESPACIO;VAR minavedestruida:BOOLEAN;
                 VAR coorescuadron:Marciano.COORESCUADRON;VAR muertos:CARDINAL);
BEGIN
    REPEAT
         Lib.Delay(15);
         Marciano.MoverEscuadron(espacio,coorescuadron,muertos,minavedestruida);
         Marciano.VisualizarEspacio(espacio);
         Marciano.Disparar(espacio,posicion,muertos,minavedestruida);
         Marciano.VisualizarEspacio(espacio);
         Lib.Delay(15);
         Marciano.Disparar(espacio,posicion,muertos,minavedestruida);
         Marciano.VisualizarEspacio(espacio);
         Lib.Delay(15);
         Marciano.Disparar(espacio,posicion,muertos,minavedestruida);
         Marciano.VisualizarEspacio(espacio);
         Lib.Delay(15);
         Marciano.Disparar(espacio,posicion,muertos,minavedestruida);
         Marciano.VisualizarEspacio(espacio);
    UNTIL (muertos=50) OR (minavedestruida);

END NivelMedio;


        (* Ejecuta el juego en nivel bajo, los niveles de juego solo
           se diferencian en el tiempo de retraso(Lib.Delay) *)
PROCEDURE NivelBajo(VAR espacio:Marciano.ESPACIO;VAR minavedestruida:BOOLEAN;
                 VAR coorescuadron:Marciano.COORESCUADRON;VAR muertos:CARDINAL);
BEGIN
    REPEAT
         Lib.Delay(30);
         Marciano.MoverEscuadron(espacio,coorescuadron,muertos,minavedestruida);
         Marciano.VisualizarEspacio(espacio);
         Marciano.Disparar(espacio,posicion,muertos,minavedestruida);
         Marciano.VisualizarEspacio(espacio);
         Lib.Delay(30);
         Marciano.Disparar(espacio,posicion,muertos,minavedestruida);
         Marciano.VisualizarEspacio(espacio);
         Lib.Delay(30);
         Marciano.Disparar(espacio,posicion,muertos,minavedestruida);
         Marciano.VisualizarEspacio(espacio);
         Lib.Delay(30);
         Marciano.Disparar(espacio,posicion,muertos,minavedestruida);
         Marciano.VisualizarEspacio(espacio);
    UNTIL (muertos=50) OR (minavedestruida);
END NivelBajo;


        (* Pregunta el nivel al cual se desea jugar *)
PROCEDURE PreguntarNivel(VAR nivel:CARDINAL);
BEGIN
    Window.GotoXY(18,6);
    IO.WrStr(" 'L'= Mover a la derecha(->)");
    Window.GotoXY(10,7);
    IO.WrStr("Control  'K'= Mover a la izquierda(<-)");
    Window.GotoXY(18,8);
    IO.WrStr(" 'D'= Disparar");

    Window.GotoXY(18,12);
    IO.WrStr(" 1.- Nivel Experto.");
    Window.GotoXY(18,13);
    IO.WrStr(" 2.- Nivel Medio.");
    Window.GotoXY(18,14);
    IO.WrStr(" 3.- Nivel Bajo.");
    Window.GotoXY(15,16);
    IO.WrStr(" Elija su nivel de juego(1/2/3): ");
    REPEAT
         nivel:=IO.RdCard();
    UNTIL (nivel>0) AND (nivel<4);
END PreguntarNivel;

        (* Ejecuta el nivel de juego seleccionado por el jugador *)
PROCEDURE EjecutarNivel(nivel:CARDINAL; VAR espacio:Marciano.ESPACIO; VAR muertos:CARDINAL;
          VAR minavedestruida:BOOLEAN; VAR coorescuadron:Marciano.COORESCUADRON);
BEGIN
    CASE nivel OF
         1: NivelExperto(espacio,minavedestruida,coorescuadron,muertos)|
         2: NivelMedio(espacio,minavedestruida,coorescuadron,muertos)  |
         3: NivelBajo(espacio,minavedestruida,coorescuadron,muertos)
    END;
END EjecutarNivel;

BEGIN
    Ventana();
    minavedestruida:=FALSE;
    muertos:=0;
    error:=FALSE;
    espacio:=Marciano.Crear(error);
    IF NOT error THEN            (* Se creo correctamente la estructura *)
       Marciano.VisualizarEspacio(espacio);
       coorescuadron.x:=1;   (* Inicializamos las coordenadas del escuadron *)
       coorescuadron.y:=1;   (* a la esquina superior izquierda de la pantalla *)
       coorescuadron.dir:=Marciano.derecha;  (* y su direccion a la derecha   *)
       posicion:=30;  (* Posicion de mi nave en la fila 25 *)
       PreguntarNivel(nivel);
       Go();
       EjecutarNivel(nivel,espacio,muertos,minavedestruida,coorescuadron);
    ELSE
       Window.GotoXY(20,20);
       IO.WrStr(" Error, no hay memoria disponible. ");
    END;
    MensajeFinal(minavedestruida);
    IF NOT error THEN      (* Si se creo la estructura, se destruye *)
       Marciano.Destruir(espacio);
    END;
END Ajugar.